<?php
define('EXTENSION_NAME', "Global Reward Points System");
define('EXTENSION_VERSION', "1.5.7");
define('EXTENSION_TYPE', "vQmod");
define('EXTENSION_COMPATIBILITY', "OpenCart 1.5.2, 1.5.2.1, 1.5.3, 1.5.4, 1.5.4.1, 1.5.5, 1.5.5.1 and 1.5.6");
define('EXTENSION_URL', "");
define('EXTENSION_SUPPORT', "gireeshmg@gmail.com");
define('EXTENSION_SUPPORT_FORUM', "");

class ControllerModuleGRP extends Controller {
    private $error = array();
    private $defaults = array(
        'grp_installed'              	=> 1,
        'grp_status'   					=> 0,
        'grp_points_per_unit'           => 1,
        'grp_desc'                    	=> 'Purchase reward point',
        'grp_redeem_desc'               => 'Used reward point',
        'grp_min_purchase_amount'       => 100,     
        'grp_min_req_points'            => 300,
        'grp_max_redeem_points'         => 500,
        'grp_value_one_reward_point'    => 0.5,
        'grp_expiry_status'             => 0,
        'grp_expiry_days'               => 365,
        'grp_remove_canceled'           => 1,
        'grp_remove_canceled_on_status' => 0,
        'grp_auto_assign_status'        => 0,
        'grp_auto_assign_on_status'     => 5,
        'grp_assign_on_cart'            => 'sub-total',
        'grp_reg_point_status'          => 0,
        'grp_reg_points'                => 50,
        'grp_reg_desc'                	=> 'Registration',
        'grp_newsletter_point_status'   => 0,
        'grp_newsletter_points'         => 10,
        'grp_newsletter_desc'           => 'Newsletter',
        'grp_review_point_status'       => 0,
        'grp_review_points'             => 5,
        'grp_review_desc'               => 'Review',
        'grp_review_mail'               => 1
    );

    public function index() {
        $this->data = array_merge($this->data, $this->load->language('module/grp'));

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
            # Loop through all settings for the post/config values
            foreach (array_keys($this->defaults) as $setting) {
                if (!isset($this->request->post[$setting])) {
                    $this->request->post[$setting] = 0;
                }
            }

            $this->model_setting_setting->editSetting('grp', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }

        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }

        if (!class_exists('VQMod')) {
            $this->data['error_warning'] = $this->language->get('error_vqmod');
        }
        
        

        if (isset($this->session->data['success'])) {
            $this->data['success'] = $this->session->data['success'];

            unset($this->session->data['success']);
        } else {
            $this->data['success'] = '';
        }

        $this->data['breadcrumbs'] = array();

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_home'),
            'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_module'),
            'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('heading_title'),
            'href'      => $this->url->link('module/grp', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );
        
      $currency = $this->currency->getSymbolLeft();
      
      $this->load->model('localisation/order_status');
      $this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        
        $this->data['hint_value_one_reward_point'] = sprintf($this->language->get('hint_value_one_reward_point'), $currency);
      $this->data['hint_points_per_unit'] = sprintf($this->language->get('hint_points_per_unit'), $currency, $currency);
      $this->data['hint_min_purchase_amount'] = sprintf($this->language->get('hint_min_purchase_amount'), $currency);

        $this->data['action'] = $this->url->link('module/grp', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['ext_name'] = EXTENSION_NAME;
        $this->data['ext_version'] = EXTENSION_VERSION;
        $this->data['ext_type'] = EXTENSION_TYPE;
        $this->data['ext_compatibility'] = EXTENSION_COMPATIBILITY;
        $this->data['ext_url'] = EXTENSION_URL;
        $this->data['ext_support'] = EXTENSION_SUPPORT;
        $this->data['ext_support_forum'] = EXTENSION_SUPPORT_FORUM;
        $this->data['ext_subject'] = sprintf($this->language->get('text_ext_subject'), EXTENSION_NAME);

        # Loop through all settings for the post/config values
        foreach (array_keys($this->defaults) as $setting) {
            if (isset($this->request->post[$setting])) {
                $this->data[$setting] = $this->request->post[$setting];
            } else {
                $this->data[$setting] = $this->config->get($setting);
                if ($this->data[$setting] === null) {
                    $this->data['error_warning'] = $this->language->get('error_unsaved_settings');
                    if (isset($this->defaults[$setting])) {
                        $this->data[$setting] = $this->defaults[$setting];
                    }
                }
            }
        }

        $this->template = 'module/grp.tpl';
        $this->children = array(
            'common/header',
            'common/footer'
        );

        $this->response->setOutput($this->render());
    }

    public function install() {
        $this->load->model('setting/setting');
        $this->model_setting_setting->editSetting('grp', $this->defaults);
    }

    public function uninstall() {
        $this->load->model('setting/setting');
        $this->model_setting_setting->deleteSetting('grp');
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'module/grp')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        /*if ($this->request->post['es_use_more_after'] < 0) {
            $this->error['warning'] = $this->language->get('error_use_more_after');
        }*/
        
        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }
}
?>