<?php
/**
 * Created by @exife
 * Website: exife.com
 * Email: support@exife.com
 * Name: Special Promotions (Cart Rules)
 */

class ModelSaleSpecialTriggers extends Model {

    public function getTriggers($data) {
        $sql = "SELECT *, DATE(date_start) date_start, DATE(date_end) date_end FROM " . DB_PREFIX . "sp_trigger WHERE 1 = 1";

        if (!empty($data['filter_name'])) {
            $sql .= " AND name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
        }

        if (!empty($data['filter_date_start'])) {
            $sql .= " AND DATE(date_start) = DATE('" . $this->db->escape($data['filter_date_start']) . "')";
        }

        if (!empty($data['filter_date_end'])) {
            $sql .= " AND DATE(date_end) = DATE('" . $this->db->escape($data['filter_date_end']) . "')";
        }

        if (isset($data['filter_status'])) {
            $sql .= " AND status = '" . (int)$data['filter_status'] . "'";
        }

        if (isset($data['filter_sort_order'])) {
            $sql .= " AND sort_order = '" . (int)$data['filter_sort_order'] . "'";
        }

        $sql .= " GROUP BY trigger_id";

        $sort_data = array(
            'name',
            'date_start',
            'date_end',
            'status',
            'sort_order'
        );

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY name";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
        }

        $query = $this->db->query($sql);

        return $query->rows;
    }

    public function getTotalTriggers($data) {
        $sql = "SELECT COUNT(DISTINCT trigger_id) AS total FROM " . DB_PREFIX . "sp_trigger WHERE 1 = 1";

        if (!empty($data['filter_name'])) {
            $sql .= " AND name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
        }

        if (!empty($data['filter_date_start'])) {
            $sql .= " AND DATE(date_start) = DATE('" . $this->db->escape($data['filter_date_start']) . "')";
        }

        if (!empty($data['filter_date_end'])) {
            $sql .= " AND DATE(date_end) = DATE('" . $this->db->escape($data['filter_date_end']) . "')";
        }

        if (isset($data['filter_status'])) {
            $sql .= " AND status = '" . (int)$data['filter_status'] . "'";
        }

        if (isset($data['filter_sort_order'])) {
            $sql .= " AND sort_order = '" . (int)$data['filter_sort_order'] . "'";
        }

        $query = $this->db->query($sql);

        return $query->row['total'];
    }

    public function addTrigger($data) {

        $this->db->query("
            INSERT INTO
                " . DB_PREFIX . "sp_trigger
            SET
                `name` = '" . $this->db->escape($data['name']) . "',
                `status` = '" . (int)$data['status'] . "',
                `coupon_type` = '" . (int)$data['coupon_type'] . "',
                `coupon_code` = '" . $this->db->escape($data['coupon_type'] ? $data['coupon_code'] : '') . "',
                `date_start` = '" . $this->db->escape($data['date_start']) . "',
                `date_end` = '" . $this->db->escape($data['date_end']) . "',
                `sort_order` = '" . (int)$data['sort_order'] . "',
                `rule` = '" . $this->db->escape(serialize($data['rule'])) . "',
                `product` = '" . $this->db->escape(serialize($data['product'])) . "',
                `cart_products` = '" . (empty($data['cart_product']) ? '' : $this->db->escape(serialize($data['cart_product']))) . "',
                `logged` = '" . (int)$data['logged'] . "',
                `store` = '" . (empty($data['store_ids']) ? '' : $this->db->escape(serialize($data['store_ids']))) . "',
                `customer_group` = '" . (empty($data['customer_group_ids']) ? '' : $this->db->escape(serialize($data['customer_group_ids']))) . "'"
        );

        $this->cache->delete('sp_trigger.' . (int)$this->db->getLastId());
        $this->cache->delete('sp_triggers');

        return $this->db->getLastId();
    }

    public function editTrigger($trigger_id, $data) {

        $this->db->query("
            UPDATE
                " . DB_PREFIX . "sp_trigger
            SET
                `name` = '" . $this->db->escape($data['name']) . "',
                `status` = '" . (int)$data['status'] . "',
                `coupon_type` = '" . (int)$data['coupon_type'] . "',
                `coupon_code` = '" . $this->db->escape($data['coupon_type'] ? $data['coupon_code'] : '') . "',
                `date_start` = '" . $this->db->escape($data['date_start']) . "',
                `date_end` = '" . $this->db->escape($data['date_end']) . "',
                `sort_order` = '" . (int)$data['sort_order'] . "',
                `rule` = '" . $this->db->escape(serialize($data['rule'])) . "',
                `product` = '" . $this->db->escape(serialize($data['product'])) . "',
                `cart_products` = '" . (empty($data['cart_product']) ? '' : $this->db->escape(serialize($data['cart_product']))) . "',
                `logged` = '" . (int)$data['logged'] . "',
                `store` = '" . (empty($data['store_ids']) ? '' : $this->db->escape(serialize($data['store_ids']))) . "',
                `customer_group` = '" . (empty($data['customer_group_ids']) ? '' : $this->db->escape(serialize($data['customer_group_ids']))) . "'
            WHERE trigger_id = '" . (int)$trigger_id . "'"
        );

        $this->cache->delete('sp_trigger.' . (int)$trigger_id);
        $this->cache->delete('sp_triggers');
    }

    public function deleteTrigger($trigger_id) {
        $this->db->query("DELETE FROM " . DB_PREFIX . "sp_trigger WHERE trigger_id = '" . (int)$trigger_id . "'");

        $this->cache->delete('sp_trigger.' . (int)$trigger_id);
        $this->cache->delete('sp_triggers');
    }

    public function statusTrigger($trigger_id) {
        $this->db->query("
            UPDATE
                " . DB_PREFIX . "sp_trigger
            SET
                `status` = 1 - `status`
             WHERE trigger_id = '" . (int)$trigger_id . "'"
        );

        $this->cache->delete('sp_trigger.' . (int)$trigger_id);
        $this->cache->delete('sp_triggers');
    }

    public function copyTrigger($trigger_id) {
        $this->db->query("
            INSERT INTO
                " . DB_PREFIX . "sp_trigger (
                    `name`,
                    `coupon_type`,
                    `coupon_code`,
                    `date_start`,
                    `date_end`,
                    `sort_order`,
                    `rule`,
                    `product`,
                    `cart_products`,
                    `logged`,
                    `store`,
                    `customer_group`
                ) SELECT
                    `name`,
                    `coupon_type`,
                    `coupon_code`,
                    `date_start`,
                    `date_end`,
                    `sort_order`,
                    `rule`,
                    `product`,
                    `cart_products`,
                    `logged`,
                    `store`,
                    `customer_group`
                FROM " . DB_PREFIX . "sp_trigger WHERE `trigger_id` = '" . (int)$trigger_id . "'");
    }

    public function getProductOptions($product_id) {
        $product_option_data = array();

        $product_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_option po LEFT JOIN `" . DB_PREFIX . "option` o ON (po.option_id = o.option_id) LEFT JOIN " . DB_PREFIX . "option_description od ON (o.option_id = od.option_id) WHERE po.product_id = '" . (int)$product_id . "' AND od.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY o.sort_order");

        foreach ($product_option_query->rows as $product_option) {
            if ($product_option['type'] == 'select' || $product_option['type'] == 'radio' || $product_option['type'] == 'checkbox' || $product_option['type'] == 'image') {
                $product_option_value_data = array();

                $product_option_value_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_option_value pov LEFT JOIN " . DB_PREFIX . "option_value ov ON (pov.option_value_id = ov.option_value_id) LEFT JOIN " . DB_PREFIX . "option_value_description ovd ON (ov.option_value_id = ovd.option_value_id) WHERE pov.product_id = '" . (int)$product_id . "' AND pov.product_option_id = '" . (int)$product_option['product_option_id'] . "' AND ovd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY ov.sort_order");

                foreach ($product_option_value_query->rows as $product_option_value) {
                    $product_option_value_data[] = array(
                        'product_option_value_id' => $product_option_value['product_option_value_id'],
                        'option_value_id'         => $product_option_value['option_value_id'],
                        'name'                    => $product_option_value['name'],
                        'image'                   => empty($product_option_value['image']) ? '' : $product_option_value['image'],
                        'quantity'                => $product_option_value['quantity'],
                        'subtract'                => $product_option_value['subtract'],
                        'price'                   => $product_option_value['price'],
                        'price_prefix'            => $product_option_value['price_prefix'],
                        'weight'                  => $product_option_value['weight'],
                        'weight_prefix'           => $product_option_value['weight_prefix']
                    );
                }

                $product_option_data[] = array(
                    'product_option_id' => $product_option['product_option_id'],
                    'option_id'         => $product_option['option_id'],
                    'name'              => $product_option['name'],
                    'type'              => $product_option['type'],
                    'option_value'      => $product_option_value_data,
                    'required'          => $product_option['required']
                );
            } else {
                $product_option_data[] = array(
                    'product_option_id' => $product_option['product_option_id'],
                    'option_id'         => $product_option['option_id'],
                    'name'              => $product_option['name'],
                    'type'              => $product_option['type'],
                    'option_value'      => $product_option['option_value'],
                    'required'          => $product_option['required']
                );
            }
        }

        return $product_option_data;
    }

    public function getTrigger($trigger_id) {
        $query = $this->db->query("SELECT *, DATE(date_start) date_start, DATE(date_end) date_end FROM " . DB_PREFIX . "sp_trigger WHERE trigger_id = '" . (int)$trigger_id . "'");

        if ($query->row) {
            $query->row['store_ids'] = $query->row['store'] ? unserialize($query->row['store']) : array();
            $query->row['customer_group_ids'] = $query->row['customer_group'] ? unserialize($query->row['customer_group']) : array();

            $query->row['rule'] = $query->row['rule'] ? unserialize($query->row['rule']) : array();
            $query->row['product'] = $query->row['product'] ? unserialize($query->row['product']) : array();

            foreach ($query->row['product'] as $key => $product) {
                if (!empty($product['option'])) {
                    $query->row['product'][$key]['options'] = $this->getProductOptions($product['product_id']);
                } else {
                    $query->row['product'][$key]['options'] = array();
                }
            }

            $this->load->model('catalog/product');
            $this->load->model('catalog/category');

            $cart_products = $query->row['cart_products'] ? unserialize($query->row['cart_products']) : array();

            $query->row['cart_products'] = array();

            foreach ($cart_products as $product_id) {
                $product_info = $this->model_catalog_product->getProduct($product_id);

                if ($product_info) {
                    $query->row['cart_products'][] = array(
                        'product_id' => $product_info['product_id'],
                        'name' => strip_tags(html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8'))
                    );
                }
            }
        }

        return $query->row;
    }

    public function editSettingValue($group = '', $key = '', $value = '', $store_id = 0) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");
        $setting_info = $query->row;

        if (version_compare(VERSION, '1.5.1') >= 0) {
            $serialized = ", serialized = '%s'";
        } else {
            $serialized = '';
        }

        if ($setting_info) {
            if (!is_array($value)) {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape($value) . "'" . ($serialized ? sprintf($serialized, 0) : '') . " WHERE `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            } else {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape(serialize($value)) . "'" . ($serialized ? sprintf($serialized, 1) : '') . " WHERE `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            }
        } else {
            if (!is_array($value)) {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `group` = '" . $this->db->escape($group) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape($value) . "'");
            } else {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `group` = '" . $this->db->escape($group) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape(serialize($value)) . "'" . ($serialized ? sprintf($serialized, 1) : '') . "");
            }
        }
    }

    public function getSettingValue($group, $key, $store_id = 0) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");

        if ($query->row) {
            if (empty($query->row['serialized'])) {
                return $query->row['value'];
            } else {
                return unserialize($query->row['value']);
            }
        } else {
            return false;
        }
    }

    public function deleteSettingValue($group, $key, $store_id = 0) {
        $this->db->query("DELETE FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `group` = '" . $this->db->escape($group) . "' AND `key` = '" . $this->db->escape($key) . "'");
    }

    public function arrayRule($rule) {
        if (!empty($rule['conditions'])) {
            $_rule = array();
            foreach ($rule['conditions'] as $positions => $item) {
                $pos = explode('--', $positions);
                $this->putIntoRule($_rule, $pos, $item);
            }
            $rule['conditions'] = $_rule;
        } else {
            $rule['conditions'] = array();
        }

        if (!empty($rule['actions'])) {
            $_rule = array();
            foreach ($rule['actions'] as $positions => $item) {
                $pos = explode('--', $positions);
                $this->putIntoRule($_rule, $pos, $item);
            }
            $rule['actions'] = $_rule;
        } else {
            $rule['actions'] = array();
        }

        return $rule;
    }

    private function putIntoRule(&$rule, $pos, $item) {
        $index = array_shift($pos) - 1;
        if (!count($pos)) {
            $rule[$index] = $item;
        } else {
            if (!isset($rule[$index]['rules'])) {
                $rule[$index]['rules'] = array();
            }
            $this->putIntoRule($rule[$index]['rules'], $pos, $item);
        }
    }
}