<?php
/**
 * Created by @exife
 * Website: exife.com
 * Email: support@exife.com
 * Name: Special Promotions (Cart Rules)
 */
?>
<?php echo $header; ?>
<div id="content">
    <div class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
            <?php echo $breadcrumb['separator']; ?><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a>
        <?php } ?>
    </div>
    <?php if ($error_warning) { ?>
    <div class="warning"><?php echo $error_warning; ?></div>
    <?php } ?>
    <div class="box">
        <div class="heading">
            <h1><img src="view/image/order.png" alt="" /> <?php echo $heading_title; ?></h1>
            <div class="buttons"><a onclick="$('#form').submit();" class="button"><span><?php echo $button_save; ?></span></a><a href="<?php echo $cancel; ?>" class="button"><span><?php echo $button_cancel; ?></span></a></div>
        </div>
        <div class="content">
            <div class="vtabs">
                <a href="#tab-main"><?php echo $tab_main; ?></a>
                <a href="#tab-conditions"><?php echo $tab_conditions; ?></a>
                <a href="#tab-content"><?php echo $tab_content; ?></a>
            </div>
            <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form">
                <div id="tab-main" class="vtabs-content">
                    <h2><?php echo $text_general_information; ?></h2>
                    <table class="form">
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_name; ?></td>
                            <td>
                                <input type="text" name="name" value="<?php echo $name; ?>" size="100" />
                                <?php if (!empty($error_name)) { ?>
                                    <span class="error"><?php echo $error_name; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_status; ?></td>
                            <td>
                                <?php if($status) {
                                    $checked1 = ' checked="checked"';
                                    $checked0 = '';
                                } else {
                                    $checked1 = '';
                                    $checked0 = ' checked="checked"';
                                } ?>
                                <label for="status_1">
                                    <?php echo $text_enabled; ?>
                                    <input type="radio"<?php echo $checked1; ?> id="status_1" name="status" value="1" />
                                </label>
                                <label for="status_0">
                                    <?php echo $text_disabled; ?>
                                    <input type="radio"<?php echo $checked0; ?> id="status_0" name="status" value="0" />
                                </label>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_store; ?></td>
                            <td>
                                <div class="scrollbox">
                                    <?php $class = 'even'; ?>
                                    <div class="<?php echo $class; ?>">
                                        <?php if (in_array(0, $store_ids)) { ?>
                                            <label>
                                                <input type="checkbox" name="store_ids[]" value="0" checked="checked" />
                                                <?php echo $text_default; ?>
                                            </label>
                                        <?php } else { ?>
                                            <label>
                                                <input type="checkbox" name="store_ids[]" value="0" />
                                                <?php echo $text_default; ?>
                                            </label>
                                        <?php } ?>
                                    </div>
                                    <?php foreach ($stores as $store) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div class="<?php echo $class; ?>">
                                            <?php if (in_array($store['store_id'], $store_ids)) { ?>
                                                <label>
                                                    <input type="checkbox" name="store_ids[]" value="<?php echo $store['store_id']; ?>" checked="checked" />
                                                    <?php echo $store['name']; ?>
                                                </label>
                                            <?php } else { ?>
                                                <label>
                                                    <input type="checkbox" name="store_ids[]" value="<?php echo $store['store_id']; ?>" />
                                                    <?php echo $store['name']; ?>
                                                </label>
                                            <?php } ?>
                                        </div>
                                    <?php } ?>
                                </div>
                                <?php if (!empty($error_store)) { ?>
                                    <span class="error"><?php echo $error_store; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><span class="required">*</span> <?php echo $entry_customer_group; ?></td>
                            <td>
                                <div class="scrollbox">
                                    <?php $class = 'odd'; ?>
                                    <?php foreach ($customer_groups as $customer_group) { ?>
                                        <?php $class = ($class == 'even' ? 'odd' : 'even'); ?>
                                        <div class="<?php echo $class; ?>">
                                            <?php if (in_array($customer_group['customer_group_id'], $customer_group_ids)) { ?>
                                                <label>
                                                    <input type="checkbox" name="customer_group_ids[]" value="<?php echo $customer_group['customer_group_id']; ?>" checked="checked" />
                                                    <?php echo $customer_group['name']; ?>
                                                </label>
                                            <?php } else { ?>
                                                <label>
                                                    <input type="checkbox" name="customer_group_ids[]" value="<?php echo $customer_group['customer_group_id']; ?>" />
                                                    <?php echo $customer_group['name']; ?>
                                                </label>
                                            <?php } ?>
                                        </div>
                                    <?php } ?>
                                </div>
                                <?php if (!empty($error_customer_group)) { ?>
                                    <span class="error"><?php echo $error_customer_group; ?></span><br />
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_logged; ?></td>
                            <td>
                                <?php if ($logged) { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="logged" value="1" checked="checked" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="logged" value="0" />
                                    </label>
                                <?php } else { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="logged" value="1" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="logged" value="0" checked="checked" />
                                    </label>
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_date_start; ?></td>
                            <td>
                                <input type="text" name="date_start" value="<?php echo $date_start == '0000-00-00' ? '' : $date_start; ?>" class="date" />
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_date_end; ?></td>
                            <td>
                                <input type="text" name="date_end" value="<?php echo $date_end == '0000-00-00' ? '' : $date_end; ?>" class="date" />
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_sort_order; ?></td>
                            <td>
                                <input type="text" name="sort_order" value="<?php echo $sort_order; ?>" size="4" />
                            </td>
                        </tr>
                    </table>
                </div>
                <div id="tab-content" class="vtabs-content">
                    <h2><?php echo $text_content; ?></h2>
                    <table class="form">
                        <tr>
                            <td><?php echo $entry_discount_method; ?></td>
                            <td>
                                <select name="discount_method">
                                    <?php if ($discount_method == 0) { ?>
                                        <option value="0" selected="selected"><?php echo $text_percent_discount; ?></option>
                                        <option value="1"><?php echo $text_fixed_discount; ?></option>
                                        <option value="2"><?php echo $text_fixed_price; ?></option>
                                    <?php } elseif ($discount_method == 1) { ?>
                                        <option value="0"><?php echo $text_percent_discount; ?></option>
                                        <option value="1" selected="selected"><?php echo $text_fixed_discount; ?></option>
                                        <option value="2"><?php echo $text_fixed_price; ?></option>
                                    <?php } elseif ($discount_method == 2) { ?>
                                        <option value="0"><?php echo $text_percent_discount; ?></option>
                                        <option value="1"><?php echo $text_fixed_discount; ?></option>
                                        <option value="2" selected="selected"><?php echo $text_fixed_price; ?></option>
                                    <?php } ?>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_discount_amount; ?></td>
                            <td>
                                <input type="text" name="discount_amount" value="<?php echo $discount_amount; ?>" />
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_show_as_special; ?></td>
                            <td>
                                <?php if ($show_as_special) { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="show_as_special" value="1" checked="checked" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="show_as_special" value="0" />
                                    </label>
                                <?php } else { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="show_as_special" value="1" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="show_as_special" value="0" checked="checked" />
                                    </label>
                                <?php } ?>
                            </td>
                        </tr>
                        <tr>
                            <td><?php echo $entry_show_label; ?></td>
                            <td>
                                <?php if ($show_label) { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="show_label" value="1" checked="checked" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="show_label" value="0" />
                                    </label>
                                <?php } else { ?>
                                    <label>
                                        <?php echo $text_yes; ?>
                                        <input type="radio" name="show_label" value="1" />
                                    </label>
                                    <label>
                                        <?php echo $text_no; ?>
                                        <input type="radio" name="show_label" value="0" checked="checked" />
                                    </label>
                                <?php } ?>
                            </td>
                        </tr>
                    </table>
                    <div id="languages" class="htabs">
                        <?php foreach ($languages as $language) { ?>
                            <a href="#language<?php echo $language['language_id']; ?>"><img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" /> <?php echo $language['name']; ?></a>
                        <?php } ?>
                    </div>
                    <?php foreach ($languages as $language) { ?>
                        <div id="language<?php echo $language['language_id']; ?>">
                            <table class="form">
                                <tr>
                                    <td><span class="required">*</span> <?php echo $entry_label; ?></td>
                                    <td>
                                        <input type="text" name="label[<?php echo $language['language_id']; ?>]" size="100" value="<?php echo isset($label[$language['language_id']]) ? $label[$language['language_id']] : ''; ?>" />
                                        <?php if (!empty($error_label[$language['language_id']])) { ?>
                                            <span class="error"><?php echo $error_label[$language['language_id']]; ?></span>
                                        <?php } ?>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    <?php } ?>
                </div>
                <div id="tab-conditions" class="vtabs-content">
                    <h2><?php echo $text_rule_to_conditions; ?></h2>
                    <table class="form">
                        <tr>
                            <td>
                                <?php
                                    function actionsTree($actions, $scope, $key = '') {

                                        if (!$key) {
                                            $out = '<div class="rule">';
                                        } elseif ($key == '1--') {
                                            $out = '<ul class="rules" data-section="actions">';
                                        } else {
                                            $out = '<ul class="rules">';
                                        }

                                        foreach($actions as $i => $action) {
                                            $k = $key . ($i + 1);

                                            if ($key) {
                                                $out .= '<li>';
                                            }

                                            $out .= '<input type="hidden" name="rule[actions][' . $k . '][type]" value="' . $action['type'] . '" />';

                                            switch ($action['type']) {
                                                case 'rule/condition_combine':
                                                    $out .= sprintf($scope['rule_condition_combine'], '<span class="data-edit" data-type="select" data-values="all_any" data-selected="' . $action['aggregator'] . '" data-name="rule[actions][' . $k . '][aggregator]"></span>', '<span class="data-edit" data-type="select" data-values="true_false" data-selected="' . $action['value'] . '" data-name="rule[actions][' . $k . '][value]"></span>');
                                                break;
                                                case 'rule/condition_product|manufacturer_id':
                                                    $out .= sprintf($scope['rule_condition_manufacturer_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="manufacturers" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|category_id':
                                                    $out .= sprintf($scope['rule_condition_category_id'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="categories" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|price_type':
                                                    $out .= sprintf($scope['rule_condition_price_type'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="select" data-values="price_types" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '"></span>');
                                                break;
                                                case 'rule/condition_product|model':
                                                    $out .= sprintf($scope['rule_condition_model'], '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>');
                                                break;
                                            }

                                            if (strpos($action['type'], 'rule/condition_product|attribute_') === 0) {
                                                $out .= $scope['values_product_conditions_page'][$action['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                            }

                                            if (strpos($action['type'], 'rule/condition_product|option_') === 0) {
                                                $out .= $scope['values_product_conditions_page'][$action['type']] . ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="' . $action['operator'] . '" data-name="rule[actions][' . $k . '][operator]"></span> ';
                                                if (substr($action['type'], -strlen('select')) === 'select' || substr($action['type'], -strlen('radio')) === 'radio' || substr($action['type'], -strlen('checkbox')) === 'checkbox' || substr($action['type'], -strlen('image')) === 'image') {
                                                    $arr = explode('|', str_replace('rule/condition_product|option_', '', $action['type']));
                                                    $out .= '<span class="data-edit" data-type="select" data-values="options_values_' . array_shift($arr) . '" data-selected="' . $action['value'] . '" data-name="rule[actions][' . $k . '][value]"></span>';
                                                } elseif (substr($action['type'], -strlen('text')) === 'text') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('textarea')) === 'textarea') {
                                                    $out .= '<span class="data-edit" data-type="textarea" data-name="rule[actions][' . $k . '][value]">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('datetime')) === 'datetime') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="datetime" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('date')) === 'date') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="date" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                } elseif (substr($action['type'], -strlen('time')) === 'time') {
                                                    $out .= '<span class="data-edit" data-type="text" data-name="rule[actions][' . $k . '][value]" data-class="time" data-selected="' . $action['value'] . '">' . ($action['value'] ? $action['value'] : '&hellip;') . '</span>';
                                                }
                                            }

                                            if (!$key) {
                                                $out .= '</div>';
                                            } else {
                                                $out .= '<img class="remove-rule" src="view/image/delete.png" alt="" valign="middle" />';
                                            }

                                            if (!empty($action['rules'])) {
                                                $out .= actionsTree($action['rules'], $scope, $k . '--');
                                            } elseif (!$key) {
                                                $out .= '<ul class="rules" data-section="actions">';
                                                $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="product_conditions_page"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';
                                                $out .= '</ul>';
                                            }

                                            if ($key) {
                                                $out.= '</li>';
                                            }
                                        }

                                        if ($key) {
                                            $out .= '<li><span class="data-edit" data-rule="new" data-type="select" data-values="product_conditions_page"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span></li>';

                                            $out .= '</ul>';
                                        }

                                        return $out;
                                    }

                                    if (empty($rule['actions'])) {
                                        $rule['actions'] = array(array('type' => 'rule/condition_combine', 'aggregator' => 'all', 'value' => '1'));
                                    }

                                    echo actionsTree($rule['actions'], $this->data);
                                ?>
                            </td>
                        </tr>
                    </table>
                </div>
            </form>
        </div>
        <p style="text-align:center; color:#222;">Special Promotions OpenCart Module v<?php echo $version; ?> - <a href="http://exife.com" target="_blank">exife.com</a></p>
    </div>
</div>
<script type="text/javascript"><!--
    var select_options = {
        all_any: $.parseJSON('<?php echo addslashes(json_encode($values_all_any)); ?>'),
        true_false: $.parseJSON('<?php echo addslashes(json_encode($values_true_false)); ?>'),
        conditions: $.parseJSON('<?php echo addslashes(json_encode($values_conditions)); ?>'),
        product_conditions: $.parseJSON('<?php echo addslashes(json_encode($values_product_conditions)); ?>'),
        product_conditions_page: $.parseJSON('<?php echo addslashes(json_encode($values_product_conditions_page)); ?>'),
        found_not_found: $.parseJSON('<?php echo addslashes(json_encode($values_found_not_found)); ?>'),
        total_qty_amount: $.parseJSON('<?php echo addslashes(json_encode($values_total_qty_amount)); ?>'),
        operators: $.parseJSON('<?php echo addslashes(json_encode($values_operator)); ?>'),
        is_is_not: $.parseJSON('<?php echo addslashes(json_encode($values_is_is_not)); ?>'),
        weekdays: $.parseJSON('<?php echo addslashes(json_encode($values_weekdays)); ?>'),
        price_types: $.parseJSON('<?php echo addslashes(json_encode($values_price_types)); ?>'),
        payment_methods: $.parseJSON('<?php echo addslashes(json_encode($values_payment_methods)); ?>'),
        shipping_methods: $.parseJSON('<?php echo addslashes(json_encode($values_shipping_methods)); ?>'),
        countries: $.parseJSON('<?php echo addslashes(json_encode($values_countries)); ?>'),
        zones: $.parseJSON('<?php echo addslashes(json_encode($values_zones)); ?>'),
        stores: $.parseJSON('<?php echo addslashes(json_encode($values_stores)); ?>'),
        customer_groups: $.parseJSON('<?php echo addslashes(json_encode($values_customer_groups)); ?>'),
        manufacturers: $.parseJSON('<?php echo addslashes(json_encode($values_manufacturers)); ?>'),
        categories: $.parseJSON('<?php echo addslashes(json_encode($values_categories)); ?>'),
        <?php $i = 0; foreach($values_options_values as $option_id => $options_values) { ?>
        options_values_<?php echo $option_id; ?>: $.parseJSON('<?php echo addslashes(json_encode($options_values)); ?>')<?php if ($i < (count($values_options_values) - 1)) { ?>,<?php } ?>
        <?php $i++; } $i = 0; ?>
    }

    if (typeof String.prototype.startsWith != 'function') {
        String.prototype.startsWith = function (str){
            return this.slice(0, str.length) == str;
        };
    }
    if (typeof String.prototype.endsWith != 'function') {
        String.prototype.endsWith = function (str){
            return this.slice(-str.length) == str;
        };
    }
//--></script>
<script type="text/javascript" src="view/javascript/jquery/ui/jquery-ui-timepicker-addon.js"></script>
<script type="text/javascript"><!--
    $(document).ready(function() {
        $('.vtabs a').tabs();
        $('.htabs a').tabs();

        $('.date').datepicker({dateFormat: 'yy-mm-dd'});

        $('.datetime').datetimepicker({
            dateFormat: 'yy-mm-dd',
            timeFormat: 'hh:mm'
        });

        $('.remove-rule').live('click', function() {
            $(this).parent().remove();
        });

        $('.time').timepicker({timeFormat: 'hh:mm'});

        $('.data-edit select').live('change', function() {
            $(this).blur();
        });

        $('.warning, .success').live('click', function() {
           $(this).remove();
        });
    });
//--></script>
<script type="text/javascript"><!--
    function refresh_edit() {
        $('.data-edit').each(function(i) {
            var _holder = this;
            $.data(_holder, 'editable.type', $(_holder).attr('data-type'));
            !$.data(_holder, 'editable.options') && $(_holder).editable({
                type: $(_holder).attr('data-type'),
                name: $(_holder).attr('data-name'),
                editClass: $(_holder).attr('data-class'),
                options: select_options[$(_holder).attr('data-values')],
                submit: ($(_holder).attr('data-class') == 'date' || $(_holder).attr('data-class') == 'time' || $(_holder).attr('data-class') == 'datetime') ? '&nbsp;<img src="view/image/success.png" alt="" valign="middle" />' : null,
                onEdit: function(content) {
                    if ($(_holder).attr('data-type') == 'text') {
                        var _input = $(_holder).find('input');

                        if (content.current == '…') {
                            _input.val('');
                        }

                        if ($(_holder).attr('data-class') == 'date') {
                            _input.datepicker({dateFormat: 'yy-mm-dd'}).datepicker('show');
                        }

                        if ($(_holder).attr('data-class') == 'time') {
                            _input.timepicker({timeFormat: 'hh:mm'}).timepicker('show');
                        }

                        if ($(_holder).attr('data-class') == 'datetime') {
                            _input.datetimepicker({dateFormat: 'yy-mm-dd', timeFormat: 'hh:mm'}).datetimepicker('show');
                        }
                    }

                    if ($(_holder).attr('data-type') == 'textarea' && content.current == '…') {
                        $(_holder).find('textarea').val('');
                    }
                },
                onSubmit: function(content) {
                    if ($.data(_holder, 'editable.type') != 'select') {
                        if (content.current && content.current != '&hellip;') {
                            $(_holder).next().val(content.current);
                        } else {
                            $(_holder).next().val('');
                            $(_holder).html('&hellip;');
                        }
                    } else {
                        $(_holder).attr('data-selected', content.current_val);
                        $(_holder).next().val(content.current_val);
                    }
                    if ($.data(_holder, 'editable.type') == 'select' && $(_holder).attr('data-rule') == 'new') {
                        var id = $(_holder).parent().index() + 1,
                            holder_list = $(_holder).parent().parent(),
                            parents, section, product_conditions;

                        parents = holder_list.parentsUntil('td', 'li');
                        $.each(parents, function(index, item) {
                            id = ($(item).index() + 1) + '--' + id;
                        });

                        id = '1--' + id;

                        $(_holder).editable('destroy');

                        section = $(_holder).parents('ul.rules').last().attr('data-section');

                        product_conditions = $(_holder).parents('ul[data-section="actions"]').length > 0 || $(_holder).attr('data-values') == 'product_conditions';

                        if (content.current_val) {
                            $(_holder).parent().replaceWith(get_part(content.current_val, id, section, product_conditions));
                            holder_list.append(get_part('rule/new', 0, section, product_conditions));
                        } else {
                            $(_holder).parent().replaceWith(get_part('rule/new', 0, section, product_conditions));
                        }
                    }

                    refresh_edit();
                }
            });
        });
    }
    refresh_edit();

    function get_part(type, id, section, product_conditions) {
        if (type == 'add') {
            return '<span class="data-edit" data-rule="new" data-type="select" data-values="' + (product_conditions ? (section == 'actions' ? 'product_conditions_page' : 'product_conditions') : 'conditions') + '"><img class="add-rule" src="view/image/add.png" alt="" valign="middle" /></span>';
        } else if (type == 'remove') {
            return '<img class="remove-rule" src="view/image/delete.png" alt="" valign="middle" />';
        }

        var html = '';
        html += '<li>';

        if (id) {
            html += '<input type="hidden" name="rule[' + section + '][' + id + '][type]" value="' + type + '"/>';
        }

        switch (type) {
            case 'rule/new':
                html += get_part('add', 0, section, product_conditions);
                break;
            case 'rule/condition_product_found':
                html += '<?php echo sprintf($rule_condition_product_found, '<span class="data-edit" data-type="select" data-values="found_not_found" data-selected="1" data-name="rule[{section}][{id}][value]"></span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>') ?>';
                break;
            case 'rule/condition_product_subselect':
                html += '<?php echo sprintf($rule_condition_product_subselect, '<span class="data-edit" data-type="select" data-values="total_qty_amount" data-selected="qty" data-name="rule[{section}][{id}][attribute]"></span>', '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>', '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>') ?>';
                break;
            case 'rule/condition_combine':
                html += '<?php echo sprintf($rule_condition_combine, '<span class="data-edit" data-type="select" data-values="all_any" data-selected="all" data-name="rule[{section}][{id}][aggregator]"></span>', '<span class="data-edit" data-type="select" data-values="true_false" data-selected="1" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|base_subtotal':
                html += '<?php echo sprintf($rule_condition_cart_base_subtotal, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|total_qty':
                html += '<?php echo sprintf($rule_condition_cart_total_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|diff_qty':
                html += '<?php echo sprintf($rule_condition_cart_diff_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|weight':
                html += '<?php echo sprintf($rule_condition_cart_weight, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|payment_method':
                html += '<?php echo sprintf($rule_condition_cart_payment_method, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="payment_methods" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_method':
                html += '<?php echo sprintf($rule_condition_cart_shipping_method, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="shipping_methods" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_postcode':
                html += '<?php echo sprintf($rule_condition_cart_shipping_postcode, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart|shipping_zone_id':
                html += '<?php echo sprintf($rule_condition_cart_shipping_zone_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="zones" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_cart|shipping_country_id':
                html += '<?php echo sprintf($rule_condition_cart_shipping_country_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="countries" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|store_id':
                html += '<?php echo sprintf($rule_condition_customer_store_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="stores" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|customer_group_id':
                html += '<?php echo sprintf($rule_condition_customer_group_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="customer_groups" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_customer|registration_date':
                html += '<?php echo sprintf($rule_condition_customer_registration_date, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|email':
                html += '<?php echo sprintf($rule_condition_customer_email, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|firstname':
                html += '<?php echo sprintf($rule_condition_customer_firstname, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_customer|lastname':
                html += '<?php echo sprintf($rule_condition_customer_lastname, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|order_num':
                html += '<?php echo sprintf($rule_condition_orders_order_num, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|sales_amount':
                html += '<?php echo sprintf($rule_condition_orders_sales_amount, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_orders|day_of_week':
                html += '<?php echo sprintf($rule_condition_day_of_week, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="weekdays" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_orders|time':
                html += '<?php echo sprintf($rule_condition_time, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|price':
                html += '<?php echo sprintf($rule_condition_cart_product_price, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|qty':
                html += '<?php echo sprintf($rule_condition_cart_product_qty, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_cart_product|total':
                html += '<?php echo sprintf($rule_condition_cart_product_total, '<span class="data-edit" data-type="select" data-values="operators" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
            case 'rule/condition_product|manufacturer_id':
            case 'rule/condition_cart_product|manufacturer_id':
                html += '<?php echo sprintf($rule_condition_manufacturer_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="manufacturers" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|category_id':
            case 'rule/condition_cart_product|category_id':
                html += '<?php echo sprintf($rule_condition_category_id, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="categories" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|price_type':
            case 'rule/condition_cart_product|price_type':
                html += '<?php echo sprintf($rule_condition_price_type, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="select" data-values="price_types" data-selected="" data-name="rule[{section}][{id}][value]"></span>') ?>';
                break;
            case 'rule/condition_product|model':
            case 'rule/condition_cart_product|model':
                html += '<?php echo sprintf($rule_condition_model, '<span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span>', '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>') ?>';
                break;
        }

        if (type.startsWith('rule/condition_cart_product|attribute_')) {
            html += select_options.product_conditions[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
        }

        if (type.startsWith('rule/condition_product|attribute_')) {
            html += select_options.product_conditions_page[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> <span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
        }

        if (type.startsWith('rule/condition_cart_product|option_')) {
            html += select_options.product_conditions[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> ';
            if (type.endsWith('select') || type.endsWith('radio') || type.endsWith('checkbox') || type.endsWith('image')) {
                html += '<span class="data-edit" data-type="select" data-values="options_values_' + type.replace('rule/condition_cart_product|option_', '').split('|').slice(0, 1) + '" data-selected="" data-name="rule[{section}][{id}][value]"></span>';
            } else if (type.endsWith('text')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('textarea')) {
                html += '<span class="data-edit" data-type="textarea" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('datetime')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="datetime">&hellip;</span>';
            } else if (type.endsWith('date')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>';
            } else if (type.endsWith('time')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>';
            }
        }

        if (type.startsWith('rule/condition_product|option_')) {
            html += select_options.product_conditions_page[type] + ' <span class="data-edit" data-type="select" data-values="is_is_not" data-selected="==" data-name="rule[{section}][{id}][operator]"></span> ';
            if (type.endsWith('select') || type.endsWith('radio') || type.endsWith('checkbox') || type.endsWith('image')) {
                html += '<span class="data-edit" data-type="select" data-values="options_values_' + type.replace('rule/condition_product|option_', '').split('|').slice(0, 1) + '" data-selected="" data-name="rule[{section}][{id}][value]"></span>';
            } else if (type.endsWith('text')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('textarea')) {
                html += '<span class="data-edit" data-type="textarea" data-name="rule[{section}][{id}][value]">&hellip;</span>';
            } else if (type.endsWith('datetime')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="datetime">&hellip;</span>';
            } else if (type.endsWith('date')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="date">&hellip;</span>';
            } else if (type.endsWith('time')) {
                html += '<span class="data-edit" data-type="text" data-name="rule[{section}][{id}][value]" data-class="time">&hellip;</span>';
            }
        }

        if (type != 'rule/new') {
            html += get_part('remove');
        }

        if (type == 'rule/condition_product_found' || type == 'rule/condition_product_subselect' || (type == 'rule/condition_combine' && product_conditions)) {
            html += '<ul class="rules" data-section="actions">';
            html += get_part('rule/new', 0, section, true);
            html += '</ul>';
        } else if (type == 'rule/condition_combine') {
            html += '<ul class="rules">';
            html += get_part('rule/new', 0, section, (section == 'actions'));
            html += '</ul>';
        }

        html += '</li>';

        return html.replace(/\{section\}/g, section).replace(/\{id\}/g, id);
    }
//--></script>
<?php echo $footer; ?>